require 'opengl'
require 'glut'

Period = 1000.0/60.0
class Draw
  @n = 0
  @@randmax = 300
  @@randmin = 3
  @@randi = 3
  @@rand = @@randmax
  @a
  @b
  
  def initialize
    @n = 0
    @a = []
    @b = []
  end
  
  def slow(t=false)
    case t
      when false
        if @@rand > @@randmin
          @@rand -= @@randi*$delta
        elsif @@rand < @@randmin
          @@rand = @@randmin
        elsif @@rand == @@randmin
          return true
        end
      when true
        if @@rand < @@randmax
          @@rand += @@randi*$delta
        elsif @@rand > @@randmax
          @@rand = @@randmax
        elsif @@rand == @@randmax
          return true
        end
      end
  end
  
  def line(x, y)
    if @a[@n] == nil
      @a << [x, y]
    elsif @b[@n] == nil
      @b << [x, y]
        @n += 1
    end
  end
  
  def delete
    @a.delete_at(@n-1)
    @b.delete_at(@n-1)
    @a.delete_at(@n)
    @b.delete_at(@n)
      @n -= 1
  end
  
  def draw(x=0, y=0)
    unless @n == 0
      @n.times do |n|
        unless @a[n] == nil or @b[n] == nil
        unless @a[n][0] == nil or @b[n][0] == nil
          Line(@a[n][0]+(rand(@@rand)-@@rand/2)+x, @a[n][1]+(rand(@@rand)-@@rand/2)+y, @b[n][0]+(rand(@@rand)-@@rand/2)+x, @b[n][1]+(rand(@@rand)-@@rand/2)+y)
        end;end
      end
    end
  end
  
  def load(n)
    f = File.new(n+".line", "rb")
      while !f.eof
        @a << [f.gets.chomp.to_i, f.gets.chomp.to_i]
        @b << [f.gets.chomp.to_i, f.gets.chomp.to_i]
          @n += 1
      end
  end
  
  def save
    w = File.new("food.line", "wb")
      @n.times do |n|
        w.puts @a[n][0]
          puts @a[n][0]
        w.puts @a[n][1]
          puts @a[n][1]
        w.puts @b[n][0]
          puts @b[n][0]
        w.puts @b[n][1]
          puts @b[n][1]
      end
    w.close
  end
end

class Snake
    @@ang = 0
      @@angr = 0
    @@lang = 0
    @@rang = 0
    
    @@width = 5
    @@speed = 1.5
    @@count = 0
    
  def initialize(x, y, ang)
    @@count = 0
    
    @ang = []
      @ang[0] = @@ang = ang
        @@angr = Convert_Ang(@@ang)
    
    @x = []
      @x[0] = x
    @y = []
      @y[0] = y
      
    @i = []
      @i[0] = @@speed*Math.cos(@@angr)
    @j = []
      @j[0] = @@speed*Math.sin(@@angr)
  end
  
  def newp
    @@count += 1
    
    @x[@@count] = @x[@@count-1]
    @y[@@count] = @y[@@count-1]
    
    @ang[@@count] = @ang[@@count-1]
  end
  
  def draw
    GL.Begin(GL::LINE_STRIP)
    @@count.times do |z|
      GL.Vertex(Convert_X(@x[z]), Convert_Y(@y[z]))
    end
    GL.End()
  end
  
  def update
    (0..(@@count)).each do |z|
      z = (@@count)-z
      
      unless z == 0
        if z > 10
          if (@x[0] < @x[z]) == !(@x[0] < @x[z-1])
              if (@y[0] < @y[z]) == !(@y[0] < @y[z-1])
                  $state.main_out(2)  #SNAKE HAS CROSSED!
        end;end;end
        
        @ang[z] = Math.atan2((@y[z]-@y[z-1]), (@x[z]-@x[z-1]))
        
        t = Math.sqrt((@y[z]-@y[z-1])*(@y[z]-@y[z-1]) + (@x[z]-@x[z-1])*(@x[z]-@x[z-1]))/@@width
        @i[z] = t*@@speed*Math.cos(@ang[z])
        @j[z] = t*@@speed*Math.sin(@ang[z])
        
        @x[z] -= @i[z]*$delta
        @y[z] -= @j[z]*$delta
        
      else
        if (@x[z] - $food.x).abs < 5 and (@y[z] - $food.y).abs < 5
          $food.collect
        end
        
        ang = Math.atan2((GraphicsHeight()/2-@y[z]), (GraphicsWidth()/2-@x[z]))
          x1 = GraphicsWidth()/2-@x[z]
          y1 = GraphicsHeight()/2.0-@y[z]
            a = Math.sqrt(x1*x1 + y1*y1)
            
          x2 = GraphicsWidth()/2.2 * Math.cos(ang)
          y2 = GraphicsHeight()/2.2 * Math.sin(ang)
            b = Math.sqrt(x2*x2 + y2*y2)
            
          x3 = 26.6*Math.cos(ang)
          y3 = 20.0*Math.sin(ang)
            c = Math.sqrt(x3*x3 + y3*y3)
          
          #a = Math.sqrt((GraphicsWidth()/2-@x[z])*(GraphicsWidth()/2-@x[z]) + (GraphicsHeight()/2.0-@y[z])*(GraphicsHeight()/2.0-@y[z]))
          #b = Math.sqrt((GraphicsHeight()/2.2*Math.sin(ang))*(GraphicsHeight()/2.2*Math.sin(ang)) + (GraphicsWidth()/2.2*Math.cos(ang))*(GraphicsWidth()/2.2*Math.cos(ang)))
          
        if a >= b
          $state.main_out(1)  #OUT OF BOUNDS!
        elsif  a <= c
          $state.main_out(3)  #CRASHED!
        else
          if not @ang[z] == @@angr
            @ang[z] = @@angr
            @i[z] = @@speed*Math.cos(@@angr)
            @j[z] = @@speed*Math.sin(@@angr)
          end
          
          @x[z] += (@i[z] + 0.7*(1-(x1/x2))*Math.cos(ang))*$delta
          @y[z] += (@j[z] + 0.7*(1-(y1/y2))*Math.sin(ang))*$delta
        end
      end
    end
  end
  
  def turn(ang)
    @@ang += ang
    @@angr = Convert_Ang(@@ang)
  end
end

class Food
  def initialize
    ang = Convert_Ang(rand(360))
      a = (GraphicsWidth()/2.2*Math.cos(ang)) * (GraphicsWidth()/2.2*Math.cos(ang))
      b = (GraphicsHeight()/2.2*Math.sin(ang)) * (GraphicsHeight()/2.2*Math.sin(ang))
    r = rand()*(Math.sqrt(a + b)-40)+30
    
    @x = r*Math.cos(ang)+320
    @y = r*Math.sin(ang)+240
    @time = Millisecs()+20000
  end
  
  def draw
    $img_food.draw(@x-7, @y-8)
    #Polygon(@x, @y, 10, 10, 8)
  end
  
  def x
    return @x
  end
  
  def y
    return @y
  end
  
  def collect
    12.times do
      $snake.newp
    end
    
    if @time-Millisecs() > 0
      $state.points(10+(@time-Millisecs())/150)
    else
      $state.points(10)
    end
    
    $food = Food.new
  end
end

class State
  @@score = 0
  @@start_screen = 1
    @@start_out = 2
  @@main_game = 3
    @@main_out_out = 4
    @@main_out_crossed = 5
    @@main_out_crashed = 6
  @@out_of_bounds = 7
    @@out_out = 8
  @@crossed_snake = 9
    @@crossed_out = 10
  @@crashed = 11
    @@crashed_out = 12
  
  def initialize
    @s = @@start_screen
  end
  
  def draw
      case @s
        when @@start_screen
          unless $img_main.slow(false) == true
            $img_main.slow(false)
          end
          $img_main.draw
          
        when @@start_out
          if $img_main.slow(true) == true
            $state.main
          else
            $img_main.slow(true)
          end
          $img_main.draw
          
        when @@main_game
          #$snake.turn($angle_change*$delta)
            #puts $angle_change.to_s
          
          $img_main.slow(false)
          $img_game.draw
            nn = 0
            @@score.to_s.each_byte do |n|
              $img_n[n.chr.to_i].draw(130+30*nn, 18)
              nn += 1
            end
          
          $snake.update
            $snake.draw
          $food.draw
          
        when @@main_out_out
          if $img_main.slow(true) == true
            $state.out
          else
            $img_main.slow(true)
          end
          $img_game.draw
          
        when @@main_out_crossed
          if $img_main.slow(true) == true
            $state.crossed
          else
            $img_main.slow(true)
          end
          $img_game.draw
          
        when @@main_out_crashed
          if $img_main.slow(true) == true
            $state.crashed
          else
            $img_main.slow(true)
          end
          $img_game.draw
          
        when @@out_of_bounds
          $img_main.slow(false)
          $img_out.draw
          
          nn = 0
          @@score.to_s.each_byte do |n|
            $img_n[n.chr.to_i].draw(175+30*nn, 40)
            nn += 1
          end
          
        when @@out_out
          if $img_main.slow(true) == true
            $state.main
          else
            $img_main.slow(true)
          end
          $img_out.draw
          
          nn = 0
          @@score.to_s.each_byte do |n|
            $img_n[n.chr.to_i].draw(175+30*nn, 30)
            nn += 1
          end
          
        when @@crossed_snake
          $img_main.slow(false)
          $img_dead.draw
          
          nn = 0
          @@score.to_s.each_byte do |n|
            $img_n[n.chr.to_i].draw(235+30*nn, 30)
            nn += 1
          end
          
        when @@crossed_out
          if $img_main.slow(true) == true
            $state.main
          else
            $img_main.slow(true)
          end
          
          $img_dead.draw
          nn = 0
          @@score.to_s.each_byte do |n|
            $img_n[n.chr.to_i].draw(235+30*nn, 40)
            nn += 1
          end
          
        when @@crashed
          $img_main.slow(false)
          $img_crash.draw
          
          nn = 0
          @@score.to_s.each_byte do |n|
            $img_n[n.chr.to_i].draw(255+30*nn, 60)
            nn += 1
          end
          
        when @@crashed_out
          if $img_main.slow(true) == true
            $state.main
          else
            $img_main.slow(true)
          end
          
          $img_crash.draw
          nn = 0
          @@score.to_s.each_byte do |n|
            $img_n[n.chr.to_i].draw(255+30*nn, 60)
            nn += 1
          end
          
      end
  end
  
  def start_out
    @s = @@start_out
  end
  
  def main
    @s = @@main_game
      $snake = Snake.new(340, 260, 30)
      @@score = 0
        20.times do; $snake.newp; end
      $food = Food.new
      
      $time = Millisecs()
      $delta = 1
  end
  
  def main_out(t=1)
    case t
      when 1
        @s = @@main_out_out
      when 2
        @s = @@main_out_crossed
      when 3
        @s = @@main_out_crashed
      end
  end
  
  def out
    @s = @@out_of_bounds
  end
  
  def out_out
    @s = @@out_out
  end
  
  def crossed
    @s = @@crossed_snake
  end
  
  def crossed_out
    @s = @@crossed_out
  end
  
  def crashed
    @s = @@crashed
  end
  
  def crashed_out
    @s = @@crashed_out
  end
  
  def s
    return @s
  end
  
  def points(n)
    @@score += n
  end
end

###########################
###########################
###########################

$mx = 320
$my = 240

$fps_c = 0
$fps_time = 0

$clscol = [0,0,0,1]

def Graphics(width, height, apptitle)
  GLUT.Init
    $fps_time = Millisecs() + 1000
  GLUT.InitDisplayMode(GLUT::RGB | GLUT::DOUBLE)
  GLUT.InitWindowSize(width, height)
  GLUT.InitWindowPosition(ScreenWidth()/2 - width/2, ScreenHeight()/2 - height/2)
  GLUT.CreateWindow(apptitle)
  
  GL.Enable(GL::BLEND)
  GL.BlendFunc(GL::SRC_ALPHA, GL::ONE_MINUS_SRC_ALPHA)
  GL.ShadeModel(GL::FLAT)
  ClsColor($clscol[0], $clscol[1], $clscol[2], $clscol[3])
end

def ClsColor(red=0, green=0, blue=0, alpha=1)
  GL.ClearColor(red/255.0, green/255.0, blue/255.0, alpha)
end

def Cls
  GL.Clear(GL::COLOR_BUFFER_BIT)
end

def Color(red, green, blue, alpha=1)
  GL.Color(red/255.0, green/255.0, blue/255.0, alpha)
end

def GraphicsWidth
  return GLUT.Get(GLUT::WINDOW_WIDTH)
end

def GraphicsHeight
  return GLUT.Get(GLUT::WINDOW_HEIGHT)
end

def ScreenWidth
  return GLUT.Get(GLUT::SCREEN_WIDTH)
end

def ScreenHeight
  return GLUT.Get(GLUT::SCREEN_HEIGHT)
end

def Flip
  #GL.Flush()
  GLUT.SwapBuffers()
end

def Polygon(x, y, w, h, d=64, rotate=0)
  w /= 2
  h /= 2
  
  GL.Begin(GL::POLYGON)
    d.times do |ang|
      ang = 360/d*ang
      
      unless rotate==0 or rotate==360
        x1 = w*$cos[ang]
        y1 = h*$sin[ang]
        
        if rotate > 360; rotate -= 360; end
          c = $cos[rotate]
          s = $sin[rotate]
          
          x2 = x1
        x1 = x1*c + y1*-s
        y1 = x2*s + y1*c
      else
        
        x1 = w*Math.cos(Convert_Ang(ang))
        y1 = h*Math.sin(Convert_Ang(ang))
      end
      
      GL.Vertex(Convert_X(x1+x), Convert_Y(y1+y))
    end
  GL.End()
end

def Line(x1, y1, x2, y2)
  GL.Begin(GL::LINE_STRIP)
    GL.Vertex(Convert_X(x1), Convert_Y(y1))
    GL.Vertex(Convert_X(x2), Convert_Y(y2))
  GL.End()
end

def Convert_X(x)
  return (2.0*x)/GraphicsWidth() - 1.0
end

def Convert_Y(y)
  return (2.0*y)/GraphicsHeight() -1.0
end

def Convert_Ang(ang)
  return (ang/180.0)*Math::PI
end

def Convert_Rad(ang)
  return (ang/Math::PI)*180.0
end

def Millisecs
  return GLUT.Get(GLUT::ELAPSED_TIME)
end

  # DISPLAY block
$display = Proc.new {
    Cls()
      $delta = (Millisecs()-$time) / (1000.0/60.0)
        $time = Millisecs()
      
      $state.draw
    Flip()
  #while (Millisecs()-time) < 1000.0/60.0
  #end
}

  # KEYBOARD block
$keyboard = Proc.new { |key, mx, my|
  case key
    when 27 #ESCAPE
      exit()
      
    when 'q'[0], 'Q'[0]
      if $state.s == 3
        $snake.turn(13)
      end
      
    when 'w'[0], 'W'[0]
      if $state.s == 3
        $snake.turn(-13)
      end
      
    when 'a'[0], 'A'[0]
      if $state.s == 3
        $snake.turn(24)
      end
      
    when 's'[0], 'S'[0]
      if $state.s == 3
        $snake.turn(-24)
      end
      
    when 015  #ENTER
      case $state.s
        when 1
          $state.start_out
        when 7
          $state.out_out
        when 9
          $state.crossed_out
        when 11
          $state.crashed_out
      end
      
    #when 'z'[0], 'Z'[0]
      #$snake.newp
    end
  
  #GLUT.DisplayFunc($display)
  GLUT.PostRedisplay()
}

  # MOUSE block
$mouse = Proc.new { |mx, my|
  $mx = mx
  $my = GraphicsHeight()-my
    
  GLUT.PostRedisplay()
}

  # *** # MAIN LOOP # *** #
Graphics(640, 480, "Space Snake")
  $img_main = Draw.new
    $img_main.load("start")
  $img_dead = Draw.new
    $img_dead.load("dead")
  $img_out = Draw.new
    $img_out.load("out")
  $img_crash = Draw.new
    $img_crash.load("crash")
  $img_game = Draw.new
    $img_game.load("game")
  $img_food = Draw.new
    $img_food.load("food")
  
  $img_n = []
  10.times do |n|
    $img_n[n] = Draw.new
      $img_n[n].load("n"+n.to_s)
  end
  
  $state = State.new
  Color(255,255,255,1)
  
  GLUT.KeyboardFunc($keyboard)
  #GLUT.MouseFunc($mouse)
  #GLUT.PassiveMotionFunc($mouse)
  #GLUT.MotionFunc($mouse)
  GLUT.DisplayFunc($display)
  GLUT.IdleFunc($display)
    $time = Millisecs()
  GLUT.MainLoop()